<template>
  <div
    class="main-content-wrap d-flex align-items-center flex-column main-wrapper secondsidenav-closed bg-white"
    :class="{'sidenav-open':isSidebarOpen}"
  >
    <lenna-modal ref="lennaModal"></lenna-modal>
    <div class="container-fluid">
      <div class="row">
        <div class="col-sm-12 bg-lighter pt-3 text-center">
          <h5 class="text-muted">Select channel you want to connect</h5>
          <p style="font-size:0.9rem"></p>
          <hr>
          <div class="row pl-5">
            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.application'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img :src="asset('images/channels/mobile.png')" class="channel-img float-left">
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Your Own Apps</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input
                    type="checkbox"
                    @click="toggleStatus($event,'mobile')"
                    v-model="status.mobile"
                  >
                  <span class="slider round"></span>
                </label>
              </div>
            </div>

            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.line'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img :src="asset('images/channels/line.png')" class="channel-img float-left">
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">LINE Messenger</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input type="checkbox" @click="toggleStatus($event,'line')" v-model="status.line">
                  <span class="slider round"></span>
                </label>
              </div>
            </div>

            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.whatsapp'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img
                      :src="asset('images/channels/whatsapp.png')"
                      class="channel-img float-left"
                    >
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Whatsapp Messenger</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input
                    type="checkbox"
                    @click="toggleStatus($event,'whatsapp')"
                    v-model="status.whatsapp"
                  >
                  <span class="slider round"></span>
                </label>
              </div>
            </div>
          </div>

          <div class="row pl-5">
            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.facebook'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img
                      :src="asset('images/channels/facebook.png')"
                      class="channel-img float-left"
                    >
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Facebook Messenger</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input
                    type="checkbox"
                    @click="toggleStatus($event,'facebook')"
                    v-model="status.facebook"
                  >
                  <span class="slider round"></span>
                </label>
              </div>
            </div>

            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.telegram'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img
                      :src="asset('images/channels/telegram.png')"
                      class="channel-img float-left"
                    >
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Telegram Messenger</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input
                    type="checkbox"
                    @click="toggleStatus($event,'telegram')"
                    v-model="status.telegram"
                  >
                  <span class="slider round"></span>
                </label>
              </div>
            </div>

            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.webchat'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img :src="asset('images/channels/webchat.png')" class="channel-img float-left">
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Webchat Messenger</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input
                    type="checkbox"
                    @click="toggleStatus($event,'webchat')"
                    v-model="status.webchat"
                  >
                  <span class="slider round"></span>
                </label>
              </div>
            </div>
          </div>
          <div class="row pl-5">
            <div class="col-2 mb-3">
              <router-link :to="{name:'integration.botintegration'}">
                <div
                  class="btn-group bg-white d-block"
                  role="group"
                  aria-label="Button group with nested dropdown"
                >
                  <button type="button" class="btn bg-white">
                    <img
                      :src="asset('/images/icons/ic_botstudio.png')"
                      class="channel-img float-left"
                    >
                  </button>
                  <button type="button" class="btn bg-white">
                    <span class="text-muted">Bot Integration</span>
                  </button>
                </div>
              </router-link>
            </div>
            <div class="col-2 d-flex align-items-center">
              <div>
                <label class="switch">
                  <input type="checkbox" @click="toggleStatus($event,'bot')" v-model="status.bot">
                  <span class="slider round"></span>
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="offset-sm-2 col-sm-8 text-dark pt-3 rounded bg-light rounded mt-5">
          <!-- <transition name="fade"> -->
          <router-view></router-view>

          <!-- </transition> -->
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";

export default {
  data() {
    return {
      status: {
        line: false,
        whatsapp: false,
        telegram: false,
        webchat: false,
        facebook: false,
        bot: false,
        mobile: false
      }
    };
  },
  methods: {
    async toggleStatus(event, channel) {
      try {
        let data = {
          status: event.target.checked,
          channelName: channel
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        EventBus.$emit("toggleStatus", channel);
        this.$refs.lennaModal.show("info", "Success", response.message);
      } catch (error) {
        this.status[channel] = !this.status[channel];
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      for (let channel of response.data) {
        if (channel.integration == null) {
          this.status[channel.name] = false;
        } else {
          this.status[channel.name] = channel.integration.status;
        }
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatusMain", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss" scoped>
.channel-img {
  width: 2.5vw;
}
.capsule {
  transition: 0.3s;
  &:hover {
    button {
      transition: 0.3s;
      background: rgb(218, 218, 218) !important;
    }
    background: rgb(218, 218, 218) !important;
  }
  border-radius: 80px !important;
}
.btn-group {
  cursor: pointer;
}

// transition
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.25s ease-out;
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}
.bg-lighter {
  background: #fdfdfd !important;
}
</style>
